from __future__ import division
from pyglet.gl import *
from constants import *

def draw_background(view_size, pos, tex, over_top=False):
    if not over_top: glBlendFunc(GL_ONE, GL_ONE)
    else: glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
    glEnable(GL_TEXTURE_2D)
    glBindTexture(GL_TEXTURE_2D, tex.id)
    glPushMatrix()
    glScalef(view_size[0] / WORLD_WIDTH,
             view_size[1] / WORLD_HEIGHT,
             1.0)
    if over_top:
        colors = [(1, 0.25, 0, 0.1), (1, 0.25, 0, 0.1)]
    else:
        colors = [(0.2, 0.05, 0, 1), (0.1, 0.1, 0, 1), (0.2, 0, 0, 1)]
    vdata, cdata, tdata = [], [], []
    for i, color in enumerate(colors):
        cdata.extend(color*4)
        glColor4f(*color)

        x = (i + 2) * pos[0] / 10000
        y = (i + 2) * pos[1] / 10000
        if over_top:
            x *= -1
            y *= -1
        vdata.extend((0, 0, WORLD_WIDTH, 0,
                      WORLD_WIDTH, WORLD_HEIGHT, 0, WORLD_HEIGHT))
        tdata.extend((x, y, x+1, y, x+1, y+.75, x, y+.75))
    pyglet.graphics.draw(len(vdata) // 2, GL_QUADS,
            ('v2f', vdata), ('c4f', cdata), ('t2f', tdata))
    glPopMatrix()
    glDisable(GL_TEXTURE_2D)
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
    glColor4f(1,1,1,1)
