import time
try:
    import json
except:
    import simplejson as json
import bz2
import StringIO
import base64

import config
from common import *
from constants import *


def encode_ghost(race):
    race.new_ghostdata = base64.b64encode(bz2.compress(json.dumps(race.new_ghostdata)))

def decode_ghost(data):
    return json.loads(bz2.decompress(base64.b64decode(data)))


def init_scores():
    if config.hiscores is None:
        config.hiscores = {}

def set_personal_score(race):
    init_scores()
    mode = race.race_mode
    score = race.player_finish_time
    date = int(time.time())
    personal_key = (mode, config.username, race.name)
    local_key = (mode, race.name)
    data = (mode, config.username, race.name, score, date, race.new_ghostdata)
    for key in [personal_key, local_key]:
        if key not in config.hiscores:
            config.hiscores[key] = []
        config.hiscores[key].append(data)
        config.hiscores[key].sort(key=lambda x: x[3])
        while len(config.hiscores[key]) > MAX_SCORES:
            config.hiscores[key].pop()
    config.save_option("hiscores")

def set_global_score(rpc, race):
    mode = race.race_mode
    score = race.player_finish_time
    date = int(time.time())
    rpc.add_hiscore(mode,
                    config.username,
                    race.name,
                    score,
                    date,
                    race.new_ghostdata).listen()


def get_personal_scores(mode, name):
    init_scores()
    key = mode, config.username, name
    if key not in config.hiscores:
        return []
    return config.hiscores[key]

def get_local_scores(mode, name):
    init_scores()
    key = mode, name
    if key not in config.hiscores:
        return []
    return config.hiscores[key]
