from entity import TrackEntity, RotatingTrackEntity
from vector import v


class Projectile(RotatingTrackEntity):
    radius = 4
    damage_output = 1
    svg_name = 'bluebullet.svg'
    is_projectile = True
    def __init__(self, race, pos, theta, angle, creator, **kwds):
        super(Projectile, self).__init__(race, pos, theta, angle, **kwds)
        self.creator = creator
        self.drag = 1
        self.speed = 10
        self.controls['thrust_rel'] = v(self.speed, 0)
        self.controls['thrust'] = self.creator.velocity
        
    def tick(self):
        super(Projectile, self).tick()
        self.controls.clear()
        
    def hit_wall(self, bump_pos, tan):
        self.race.remove_entity(self)
        self.race.explode_at(self.pos, self.theta)
        
    def hit(self, other):
        self.hit_by(other)
        
    def hit_by(self, other):
        super(Projectile, self).hit_by(other)
        other.hp -= self.damage_output
        self.hp = 0
        self.race.explode_at(self.pos, self.theta)
        
    def can_collide_with(self, other):
        if not super(Projectile, self).can_collide_with(other):
            return False
        if isinstance(other, Projectile):
            return False
        return (other is not self.creator)
    