order = [
    "George Washington",
    "John Adams",
    "Thomas Jefferson",
    "James Madison",
    "James Monroe",
    "John Quincy Adams",
    "Andrew Jackson",
    "Martin van Buren",
    "William Henry Harrison",
    "John Tyler",
    "James K. Polk",
    "Zachary Taylor",
    "Millard Fillmore",
    "Franklin Pierce",
    "James Buchanan",
    "Abraham Lincoln",
    "Andrew Johnson",
    "Ulysses S. Grant",
    "Rutherford B. Hayes",
    "James A. Garfield",
    "Chester A. Arthur",
    "Grover Cleveland",
    "Benjamin Harrison",
    "Grover Cleveland",
    "William McKinley",
    "Theodore Roosevelt",
    "William Howard Taft",
    "Woodrow Wilson",
    "Warren G. Harding",
    "Calvin Coolidge",
    "Herbert Hoover",
    "Franklin D. Roosevelt",
    "Harry S Truman",
    "Dwight D. Eisenhower",
    "John F. Kennedy",
    "Lyndon B. Johnson",
    "Richard Nixon",
    "Gerald Ford",
    "Jimmy Carter",
    "Ronald Reagan",
    "George H. W. Bush",
    "Bill Clinton",
    "George W. Bush",
    "Barack Obama",
]


forward = {
    "George Washington" : ["Washington"],
    "John Adams" : [],
    "Thomas Jefferson" : ["Jefferson"],
    "James Madison" : ["Madison"],
    "James Monroe" : ["Monroe"],
    "John Quincy Adams" : [],
    "Andrew Jackson" : ["Jackson"],
    "Martin van Buren" : ["van Buren"],
    "William Henry Harrison" : [],
    "John Tyler" : ["Tyler"],
    "James K. Polk" : ["Polk"],
    "Zachary Taylor" : ["Taylor"],
    "Millard Fillmore" : ["Fillmore"],
    "Franklin Pierce" : ["Pierce"],
    "James Buchanan" : ["Buchanan"],
    "Abraham Lincoln" : ["Lincoln"],
    "Andrew Johnson" : [],
    "Ulysses S. Grant" : ["Grant"],
    "Rutherford B. Hayes" : ["Hayes"],
    "James A. Garfield" : ["Garfield"],
    "Chester A. Arthur" : ["Arthur"],
    "Grover Cleveland" : ["Cleveland"],
    "Benjamin Harrison" : [],
    "William McKinley" : ["McKinley"],
    "Theodore Roosevelt" : [],
    "William Howard Taft" : ["Taft"],
    "Woodrow Wilson" : ["Wilson"],
    "Warren G. Harding" : ["Harding"],
    "Calvin Coolidge" : ["Coolidge"],
    "Herbert Hoover" : ["Hoover"],
    "Franklin D. Roosevelt" : ["FDR"],
    "Harry S Truman" : ["Truman"],
    "Dwight D. Eisenhower" : ["Eisenhower", "Ike"],
    "John F. Kennedy" : ["Kennedy", "JFK"],
    "Lyndon B. Johnson" : [],
    "Richard Nixon" : ["Nixon"],
    "Gerald Ford" : ["Ford"],
    "Jimmy Carter" : ["Carter"],
    "Ronald Reagan" : ["Reagan"],
    "George H. W. Bush" : [],
    "Bill Clinton" : ["Clinton"],
    "George W. Bush" : [],
    "Barack Obama" : ["Obama"],
}

facts = {
    "George Washington" : "had teeth carved from hippopotamus ivory, held together with gold springs.",
    "John Adams" : "got lost in the woods near the White House for several hours.",
    "Thomas Jefferson" : "gouged chips out of a chair in Shakespeare's house to take home as a souvenir.",
    "James Madison" : "was the first president to wear trousers.",
    "James Monroe" : "chased his Secretary of State out of the White House with a pair of fire tongs.",
    "John Quincy Adams" :"kept a pet alligator and swam naked in the Potomac every morning.",
    "Andrew Jackson" : "had a pet parrot which had to be removed from his funeral for swearing too much.",
    "Martin Van Buren" : "briefly kept two tiger cubs.",
    "William Henry Harrison" : "campaigned with bottles of cider shaped like log cabins.",
    "John Tyler" : "had fifteen children.",
    "James K. Polk" : "banned dancing in the White House. Despite his name, he did not invent the Polka.",
    "Zachary Taylor" : "refused to pay postage on his presidential nomination.",
    "Millard Fillmore" : "installed the White House bath tub.",
    "Franklin Pierce" : "was the first president to have a Christmas tree.",
    "James Buchanan" : "had to sleep in the hall when the Prince of Wales visited the White House.",
    "Abraham Lincoln" : "was the only president to have been a licensed bartender.",
    "Andrew Johnson" : "would only wear suits he made himself.",
    "Ulysses S. Grant" : "was arrested while in office for driving his horse too fast.",
    "Rutherford B. Hayes" : "did not allow booze in the White House.",
    "James A. Garfield" : "could write in Greek and Latin at the same time, one with each hand.",
    "Chester A. Arthur" : "was nicknamed \"Elegant Arthur\".",
    "Grover Cleveland" : "had a secret rubber jawbone.",
    "Benjamin Harrison" : "was afraid of electricity (unlike Benjamin Franklin).",
    "William McKinley" : "was nicknamed \"Wobbly Willy\".",
    "Theodore Roosevelt" : "killed four mountain lions with a knife after they attacked his dogs.",
    "William Howard Taft" : "weighed more than a baby elephant and once got stuck in the White House bathtub.",
    "Woodrow Wilson" : "holds the record for most rounds of golf played by a sitting president.",
    "Warren G. Harding" : "lost the White House china in a game of cards.",
    "Calvin Coolidge" : "liked to press all the buttons in Oval Office to watch his entire staff run in.",
    "Herbert Hoover" : "ordered his servants to hide in his presence.",
    "Franklin D. Roosevelt" : "invested in a dirigible freight business.",
    "Harry S. Truman" : "was the first US president to ride in a submarine.",
    "Dwight D. Eisenhower" : "was the first president licensed to fly an aeroplane.",
    "John F. Kennedy" : "was the first president to have been a boy scout.",
    "Lyndon B. Johnson" : "had a special buzzer for the Secret Service to warn him when his wife was approaching.",
    "Richard Nixon" : "was given a gun by Elvis.",
    "Gerald Ford" : "modelled for Cosmopolitan and Look magazines.",
    "Jimmy Carter" : "was attacked by a bunny.",
    "Ronald Reagan" : "released an album called \"Ronald Reagan Speaks Out Against Socialized Medicine\".",
    "George H. W. Bush" : "vomited on the Prime Minister of Japan. \"Bushusuru\" now means vomit in Japanese.",
    "Bill Clinton" : "was attacked by a sheep at the age of 8.",
    "George W. Bush" : "proclaimed June 10 to be Jesus Day in Texas.",
    "Barack Obama" : "collects \"Conan the Barbarian\" comics.",
}

def canonicalise(str):
    return str.strip().title()

# Canonicalise the forward list.
for president in list(forward):
    forward[president] = map(canonicalise, forward[president])
    forward[president].append(canonicalise(president))

# Construct the reverse list.
reverse = {}
for president in forward:
    for synonym in forward[president]:
        assert synonym not in reverse
        reverse[synonym] = president

def resolve(name):
    name = canonicalise(name)
    return reverse.get(name, name)



## Seasons
##########

seasons = {
    "Founding Fathers": ["George Washington", "John Adams",
                         "Thomas Jefferson", "James Madison"],
    "Rushmore": ["George Washington", "Thomas Jefferson",
                 "Abraham Lincoln", "Theodore Roosevelt"],
    "Assassinations": ["Abraham Lincoln", "James A. Garfield",
                       "William McKinley", "John F. Kennedy"],
    "Natural Causes": ["William Henry Harrison", "Zachary Taylor",
                       "Warren G. Harding", "Franklin D. Roosevelt"],
    "Fathers And Sons": ["John Adams", "John Quincy Adams",
                         "George H. W. Bush", "George W. Bush"],
    "Whigs": ["William Henry Harrison", "John Tyler",
              "Zachary Taylor", "Millard Fillmore"],
    "American Alliteration": ["Woodrow Wilson", "Calvin Coolidge",
                              "Herbert Hoover", "Ronald Reagan"],
}

seasonorder = [
    "Founding Fathers",
    "Assassinations",
    "Natural Causes",
    "Fathers And Sons",
    "Whigs",
    "American Alliteration",
    "Rushmore"
]

seasonforward = {
}

# Canonicalise the forward list.
for season in list(seasonforward):
    seasonforward[season] = map(canonicalise, seasonforward[season])
    seasonforward[season].append(canonicalise(season))

# Construct the reverse list.
seasonreverse = {}
for season in seasonforward:
    for synonym in seasonforward[season]:
        assert synonym not in seasonreverse
        seasonreverse[synonym] = season

def seasonresolve(name):
    name = canonicalise(name)
    return seasonreverse.get(name, name)
