from rpc.server import makerpc
from google.appengine.ext import db
from constants import *

class HiScore(db.Model):
    mode = db.StringProperty()
    username = db.StringProperty()
    track = db.StringProperty()
    score = db.IntegerProperty()
    date = db.IntegerProperty()
    ghost = db.BlobProperty()
    
def get_player_hiscore(handler, mode, username, track):
    query = HiScore.all()
    query.filter("track =", track)
    query.filter("mode =", mode)
    query.filter("username =", username)
    for hs in query.fetch(1):
        return hs

@makerpc
def add_hiscore(handler, mode, username, track, score, date, ghost):
    previous_best = get_player_hiscore(handler, mode, username, track)
    if (not previous_best) or (score < previous_best.score):
        if isinstance(ghost, unicode):
            ghost = ghost.encode('ascii')
        HiScore(mode=mode,
                username=username,
                track=track,
                score=score,
                date=date,
                ghost=ghost).put()
        if previous_best is not None:
            previous_best.delete()
        

@makerpc
def get_hiscores(handler, mode, track):
    results = []
    query = HiScore.all()
    query.filter("track =", track)
    query.filter("mode =", mode)
    query.order("score")
    for hs in query.fetch(MAX_SCORES):
        results.append((hs.mode,
                        hs.username,
                        hs.track,
                        hs.score,
                        hs.date,
                        hs.ghost))
    return results
